/*---------------------------------------------------------------------*/
/* --------------------------------------------------------------------*/
/* --------------------------------------------------------------------*/
/* --------------------------------------------------------------------*/
/* ---    дС            ---------------------------------------*/
/*---------------------------------------------------------------------*/


#include   "System_init.h"


#define   Time0_1ms     ( 65536-(MAIN_Fosc/1000) )				//T0 1msʱʼֵ
#define   Time3_10ms    ( 65536-(MAIN_Fosc/12/1000*10) )		//T3 1msʱʼֵ

#define   Uart1_baud    ( 65536 - (MAIN_Fosc/4/115200) )				//Uart1 


/************************************************************************/
/* : void delay_ms(unsigned int ms)									*/
/* : ʱ														*/
/* : ʱ24MHZ														*/
/* : None.															*/
/* 汾: V1.0  2023-10-02												*/
/************************************************************************/
void delay_ms(unsigned int ms)
{
	unsigned int i;
	do{
		i = MAIN_Fosc / 10000;
		while(--i);
	}while(--ms);
}


/************************************************************************/
/* : void	GPIO_config(void)										*/
/* : IO											     		*/
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void	GPIO_config(void)
{
	P0_MODE_IO_PU(GPIO_Pin_3);
	
	P0_MODE_IN_HIZ(GPIO_Pin_4|GPIO_Pin_5);
	
	P0_MODE_OUT_PP(GPIO_Pin_1|GPIO_Pin_2);
	
	P7_MODE_OUT_PP(GPIO_Pin_3);	
	
	P4_MODE_OUT_PP(GPIO_Pin_0);
	
  	P6_MODE_OUT_PP(GPIO_Pin_HIGH);	
	
	P3_MODE_OUT_PP(GPIO_Pin_1);
	
	P3_MODE_IO_PU(GPIO_Pin_0);
	
}




/************************************************************************/
/* : void	UART1_config(void)										*/
/* : 1											     		*/
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void	UART1_config(void)	
{
	SCON = 0x50;				//8λ,ɱ䲨
	AUXR = 0x00;				//1ѡʱ1Ϊʷ
	AUXR |= 0x40;				//ʱʱ1Tģʽ	
//	TMOD &= 0x0F;				//öʱģʽ	
	TH1 = Uart1_baud >> 8;		//öʱʼֵ
	TL1 = Uart1_baud;			//öʱʼֵ
	ET1 = 0;					//ֹʱ%dж
	TR1 = 1;					//ʱ1ʼʱ
	ES  = 1;					//ж
}



/************************************************************************/
/* : void	Timer_config(void)										*/
/* : 1											     		*/
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void	Timer_config(void)
{
	AUXR |= 0x80;				//ʱʱ1Tģʽ
	
//	TMOD &= 0xF0;				//öʱģʽ
	TH0 = Time0_1ms >> 8;		//öʱʼֵ
	TL0 = Time0_1ms;			//öʱʼֵ
	TF0 = 0;					//TF0־
	TR0 = 1;					//ʱ0ʼʱ
	ET0 = 1;
	
	T4T3M &= 0xFD;				//ʱʱ12Tģʽ
	T3H = Time3_10ms >> 8;		//öʱʼֵ
	T3L = Time3_10ms;			//öʱʼֵ
	T4T3M |= 0x08;				//ʱ3ʼʱ
	IE2 |= ET3;

}

/************************************************************************/
/* : void ADC_config()          									*/
/* : ADC										        		    */
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void ADC_config(void)
{
	EAXSFR();
    ADCTIM = 0x3f;                              //ADCڲʱ
    ADCCFG = 0x0f;                              //ADCʱΪϵͳʱ/2/16
    ADC_CONTR = 0x80;                           //ʹADCģ	
	ADC_CONTR |= 0x80;	
	EAXRAM();
}

/************************************************************************/
/* : void WDT_init(void)    										*/
/* : Źʼ 													*/
/* : Ƶ24MHZ Źλʱ1.048									*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void WDT_init(void)
{
	WDT_CONTR = 0x04;       //Źʱʱ㹫ʽ: (12 * 32768 * PS) / FOSC ()
                            //ÿŹʱƵΪ32,ʱ:
                            //11.0592M : 1.14s
                            //18.432M  : 0.68s
                            //20M      : 0.63s
    WDT_CONTR |= 0x20;      //Ź
}


/************************************************************************/
/* : void Touch_config(void)	   									*/
/* : //													*/
/* : None															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void Touch_config(void)		
{
	u8 i;
	
	EAXSFR();											/* MOVX A,@DPTR/MOVX @DPTR,AָĲΪչSFR(XSFR) */
	
	TSCHEN1 = 0x33;										//ʹTK0 TK1 TK4 TK5
	TSCHEN2 = 0x08;										//ʹTK11
	TSRT = 0x00;										//ûLEDʱɨ		
	TSCFG1  = (7<<4) + 6;								//صݹƵ = fosc/(2*(TSCFG1[6:4]+1)), ŵʱ(ϵͳʱ) 0(125) 1(250) 2(500) 3(1000) 4(2000) 5(2500) 6(5000) 7(7500) С3
	TSCFG2  = 1;										//ôڲοѹ(AVCCķѹ), 0(1/4)  1(1/2)  2(5/8)  3(3/4)	
//	TSCTRL = (1<<7) + (1<<6) +3;						//ʼɨ, B7: TSGO,  B6: SINGLE,  B5: TSWAIT, B4: TSWUCS, B3: TSDCEN, B2: TSWUEN, B1 B0: TSSAMP		
	IE2 |= 0x80; 										//ж	
	P1_MODE_IN_HIZ(GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5);	// Ϊ TK0 TK1 TK4 TK5 
	P5_MODE_IN_HIZ(GPIO_Pin_3);										//Ϊ TK11 
	delay_ms(100);										//ʱһ
	B_TK_Lowpass = 0;									//ֹͨ˲
	for(read_cnt=0; read_cnt<32; read_cnt++)			//ɨ10μ, ֵΪδʱ0, ҪϵʱҪ
	{
		TSCTRL = (1<<7) + (1<<6);						//ʼɨ, ƽ
		delay_ms(10);									//ʱһ, ȴɨ
	}
	for(i=0; i<16; i++)	
	TK_zero[i] = TK_cnt[i]-600;								//0   豸ϵ粻ܴ
	B_TK_Lowpass = 1;									//ͨ˲
	KeyState = 0;
	read_cnt = 0;
	EAXRAM();											/* MOVX A,@DPTR/MOVX @DPTR,AָĲΪչRAM(XRAM) */
}

 /************************************************************************/
/* : void LCD_config(void)   	   									*/
/* : //													*/
/* : None															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void LCD_config(void)
{
	EAXSFR();						/* MOVX A,@DPTR/MOVX @DPTR,AָĲΪչSFR(XSFR) */	
	LCDCFG  = 7;					// 0x00:ѡCPUʱΪLCDʱ, VLCDѹѡ4.8V	
	DBLEN   = 2;					// LCDʾʱʱ䳤, ȡֵ0~7.
	
	COMLENH	= 0X01;					// COMʱ䳤 ֽCOMLEN[19:16],  һ20bit.	
	COMLENM	= 0X86;					// COMʱ䳤 ֽCOMLEN[15:8]	LCDˢ = LCDʱƵ / ((DBLEN[2:0]+COMLEN[19:0]+1) *2 * COM)
	COMLENL	= 0X9d;					// COMʱ䳤 ֽCOMLEN[7:0]	LCDˢ = 32768/((2+65+1)*2*4) = 60Hz
	
	COMON  = 0x0F;					// COMʹܼĴ	
	SEGON1 = 0x00;					// SEGʹܼĴ1, SEG7~SEG0
	SEGON2 = 0x00;					// SEGʹܼĴ2, SEG15~SEG8
	SEGON3 = 0xFF;					// SEGʹܼĴ3, SEG23~SEG16
	SEGON4 = 0xFF;					// SEGʹܼĴ4, SEG31~SEG24
	SEGON5 = 0x00;					// SEGʹܼĴ5, SEG39~SEG32	
	P5_MODE_IN_HIZ(GPIO_Pin_0|GPIO_Pin_1);	
	P3_MODE_IN_HIZ(GPIO_Pin_5|GPIO_Pin_6);		// Ϊ COM1-COM4
	
	P0_MODE_IN_HIZ(GPIO_Pin_0);					// Ϊ SEG16
	P4_MODE_IN_HIZ(GPIO_Pin_6|GPIO_Pin_5);		// Ϊ SEG17 - SEG18
	P2_MODE_IN_HIZ(GPIO_Pin_All);				// Ϊ SEG19 - SEG26
	P4_MODE_IN_HIZ(GPIO_Pin_4|GPIO_Pin_3|GPIO_Pin_2|GPIO_Pin_1);	
												// Ϊ SEG27 - SEG30
	LCDCR = 1;						// LCDƼĴ ģʽ  ʹLCD
	EAXRAM();						/* MOVX A,@DPTR/MOVX @DPTR,AָĲΪչRAM(XRAM) */

}

/************************************************************************/
/* : void RAM_Init(void)         									*/
/* : RAMʼ 													    */
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void RAM_Init(void)
{
	memset(&Work, 0, sizeof(Work));
	memset(&Set, 0, sizeof(Set));
	memset(&LCD_buff, 0, sizeof(LCD_buff));	
	
	
	Set.ON_OFF = OFF;
	Set.mode =  Rset_mode;
	Set.Time = Rset_time;
	Set.Intensity = Rset_Intensity;			//Ĭǿ
		
}

/************************************************************************/
/* : void	SYS_Init(void)											*/
/* : ϵͳʼ 														*/
/* : None.															*/
/* : None.															*/
/* 汾: V1.0  2024-01-02												*/
/************************************************************************/
void SYS_Init(void)
{
	delay_ms(200);				//ʱ
	RAM_Init();					//RAMݳʼ
	GPIO_config();				//˿	
	UART1_config();
	Timer_config();				//ʱ
	EA = 1;						//ʹȫж	
	Touch_config();				//
	LCD_config();				//LCD
	ADC_config();				//ADC
#ifdef ENABLE_EEPROM	
	EEPROM_init();				//EEPROMʼ
#endif
	WDT_init();					//ʹܿŹŹλʱԼ1.14		
}

/**********************   END  *******************************************/
